/*
 * Timer.java
 *
 * Created on June 8, 2007, 7:09 PM
 * Třída nastavuje 4 bity v registru TMOD. Jsou proto 2 instance -
 * 0. pro Timer 0 a 1. pro Timer 1
 */

package my.initx51;

/**
 *
 * @author  Mrazik
 */
public class Timer extends javax.swing.JPanel {
    HlavniPanel Parent;                         // je potřeba vědět, odkud je to voláno
    int Mode,TMOD,Time,Instance;
    String sTime;
    /** Creates new form Timer */
    public Timer() {
        initComponents();
        sTime = new String ();
    }
    public Timer (HlavniPanel F, int inst) {
        initComponents();
        sTime = new String ();
        
        Parent   = F;
        Instance = inst;                        // Timer 0/1
        if (inst == 1)                          // Timer 1
            jComboBox1.removeItemAt(3);         // nemůže být v módu 3
    }
    // někdy je potřeba celou záložku prostě zakázat
    public void EnableAll (boolean b) {
        if (!b) {
            jComboBox1.setSelectedIndex(2);
            jCheckBox2.setSelected(true);
        }
        jCheckBox1.setEnabled(b);
        jCheckBox2.setEnabled(b);
        jComboBox1.setEnabled(b);
        jLabel1.setEnabled(b);
        jRadioButton1.setEnabled(b);
        jRadioButton2.setEnabled(b);
        jLabel2.setEnabled(b);
        jTextField1.setEnabled(b);
        if (b) {
            if (Instance == 1) Parent.mIntr.EnableIntTim1();
        }
        else {
            if (Instance == 1) Parent.mIntr.DisableIntTim1();
        }
    }
    // spočte příslušnou polovinu registru TMOD
    public int getTMOD () {
        TMOD  = 0;
        TMOD |= Mode;                                   // nejnižší 2 bity
        if (jCheckBox1.isSelected())    TMOD |= 0x80;   // GATE
        if (jRadioButton2.isSelected()) TMOD |= 0x40;   // C/T
        return TMOD;
    }
    // povolit při startu ?
    public boolean getStart () {
        return (jCheckBox2.isSelected());
    }
    // vrací počet tiků časovače za zadaný čas
    public int getTime () {
        return Time;
    }
    // Podle módu povolí/zakáže nastavení času. Je to povoleno jen v módu 1,
    // ostatní závislosti jsem nepitval, nepřijdou mi podstatné.
    public void setTime () {
        if ((Mode != 1) | jCheckBox1.isSelected() | jRadioButton2.isSelected()) {
            jLabel2.setEnabled(false);
            jTextField1.setEnabled(false);
            Time = 0;
        }
        else {
            jLabel2.setEnabled(true);
            jTextField1.setEnabled(true);
        }
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jTextField1 = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();

        buttonGroup1.add(jRadioButton1);
        jRadioButton1.setSelected(true);
        jRadioButton1.setText("\u010c\u00edta\u010d");
        jRadioButton1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });

        buttonGroup1.add(jRadioButton2);
        jRadioButton2.setText("\u010casova\u010d");
        jRadioButton2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        });

        jLabel1.setText("M\u00f3d:");

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0 - 8bit s 5bit p\u0159edd\u011bli\u010dkou", "1 - 16bit", "2 - 8bit autoreload", "3 - 0.\u010d. 2x8bit, 1.\u010d. BaudGen" }));
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        jCheckBox1.setText("Povolit hradlov\u00e1n\u00ed (Gate)");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });

        jCheckBox2.setText("Spustit p\u0159i startu");
        jCheckBox2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox2.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jTextField1.setEnabled(false);
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });

        jLabel2.setText("P\u0159ibli\u017en\u00fd \u010das [us] :");
        jLabel2.setEnabled(false);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jComboBox1, 0, 334, Short.MAX_VALUE))
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                            .add(jRadioButton1)
                            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(jRadioButton2))
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jCheckBox1))
                    .add(jCheckBox2)
                    .add(layout.createSequentialGroup()
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jTextField1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 252, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jCheckBox1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jRadioButton1)
                    .add(jRadioButton2))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 79, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(jTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(97, 97, 97)
                .add(jCheckBox2)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton2ActionPerformed
        setTime ();
    }//GEN-LAST:event_jRadioButton2ActionPerformed

    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        setTime ();
    }//GEN-LAST:event_jCheckBox1ActionPerformed

    private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        setTime ();
    }//GEN-LAST:event_jRadioButton1ActionPerformed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        Integer IFosc,ITmp;
        Double  fFosc,fTmp;
        sTime    = jTextField1.getText();
        /** Metoda je pouze približná, ono to stejně chvíli trvá než přerušení
         * doběhne až k naplnění TH,TL. Protože ta doba může být různá podle
         * překladače, nemá cenu se tím hlouběji zabývat.
         */
        IFosc = Parent.getFosc();
        fFosc = IFosc.doubleValue();
        try {
            ITmp = Integer.parseInt(sTime);
            fTmp = ITmp.doubleValue();
            fTmp = fTmp * fFosc / 12000000.0;       // dělí se to 12, ale je to v usec takže ještě milionem
            Time = fTmp.intValue();
            if (Time >= 0x10000) {
                Time = 0;
                int x = 1 / Time;                   // vyvolá vyjímku, dál to neřeším
            }
        } catch (Exception ie) {
                // chybové okno
                javax.swing.JOptionPane.showMessageDialog(this,ie.getMessage(),"Chyba zadání času",javax.swing.JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        Mode = jComboBox1.getSelectedIndex();
        setTime ();
    }//GEN-LAST:event_jComboBox1ActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables
    
}
